/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id: assessment.js,v 1.1.2.1 2015/06/30 11:04:37 rakollep Exp $ */
 
var CbtView = false;

function getStudentAssessmentID()
{
	return getAssessmentForm().studentAssessID.value;
}

function getExpirationDate()
{
	var now = new Date();
		now.setFullYear(now.getFullYear() + 1);

	return now;
}

function setCookieValue(answerString)
{
	var answersSaved = false;
	var MAX_COOKIE_SIZE = 3584; // 3.5K
	var cookieExpirationDate = getExpirationDate().toGMTString();
	var encodedAnswerString = escape(answerString);

	if (encodedAnswerString.length <= MAX_COOKIE_SIZE)
	{
		document.cookie = "persistenceMode=cookie;expires="+cookieExpirationDate;
		document.cookie = "currentPage="+currentPage+";expires="+cookieExpirationDate;
		document.cookie = getStudentAssessmentID()+"="+encodedAnswerString+";expires="+cookieExpirationDate;

		if (document.cookie.indexOf(getStudentAssessmentID()) > -1)
		{
			answersSaved = true;
		}
	}
	else
	{
		if (window.navigator.userAgent.indexOf("MSIE") > -1)
		{
			var IE_TOKEN = "MSIE";
			var start = window.navigator.userAgent.indexOf(IE_TOKEN)+IE_TOKEN.length;
			var end = window.navigator.userAgent.indexOf(";",start);
			var IEversion = parseInt(window.navigator.userAgent.substring(start,end));

			if (IEversion >= 5)
			{
				document.cookie = "persistenceMode=userData;expires="+cookieExpirationDate;
				document.cookie = "currentPage="+currentPage+";expires="+cookieExpirationDate;

				var userDataObject = document.getElementById("spnUserData");
					userDataObject.expires = getExpirationDate().toUTCString();
					userDataObject.setAttribute("answerBody",encodedAnswerString);
					userDataObject.save(getStudentAssessmentID());

				answersSaved = true;
			}
		}
		else
		{

			if (encodedAnswerString.length / MAX_COOKIE_SIZE < 19)
			{

				document.cookie = "persistenceMode=brokenCookie;expires="+cookieExpirationDate;

				var pos = 0;
				var count = 0;

				while (pos < encodedAnswerString.length)
				{
					var end = pos + MAX_COOKIE_SIZE;
					if (end > encodedAnswerString.length)
					{
						end = encodedAnswerString.length;
					}

					var cookieChunk = encodedAnswerString.substring(pos,end);
					document.cookie = getStudentAssessmentID()+"["+count+"]="+cookieChunk+";expires="+cookieExpirationDate;

					count++;
					pos = end+1;
				}

				answersSaved = true;
			}
		}
	}

	if (!answersSaved)
	{
		alert("Unable to save answers");
	}
}

function getPersistenceMode()
{
	var TOKEN = "persistenceMode";
	var cookieTemp = document.cookie;

	var pos = cookieTemp.indexOf(TOKEN);
	if (pos < 0)
	{
		return null;
	}

	var start = pos+TOKEN.length+1;
	var end = cookieTemp.indexOf(";",start);
	if (end < 0)
	{
		end = cookieTemp.length;
	}
	return cookieTemp.substring(start,end);
}

function getCurrentPage()
{
	var TOKEN = "currentPage";
	var cookieTemp = document.cookie;

	var pos = cookieTemp.indexOf(TOKEN);
	if (pos < 0)
	{
		return currentPage;
	}

	var start = pos+TOKEN.length+1;
	var end = cookieTemp.indexOf(";",start);
	if (end < 0)
	{
		end = cookieTemp.length;
	}
	return cookieTemp.substring(start,end);
}

function getCookieValue()
{

	var persistenceMode = getPersistenceMode();

	if (persistenceMode != null)
	{
		if (persistenceMode == "cookie")
		{
			var saID = getStudentAssessmentID();
			var cookieArray = document.cookie.split(";");

			for (var i=0; i<cookieArray.length; i++)
			{
				var cookieTemp = cookieArray[i];
				var pos = cookieTemp.indexOf(saID)

				if (pos < 0) continue;

				var start = pos+saID.length;

				if (cookieTemp.charAt(start) == "=")
				{
					var end = cookieTemp.indexOf(";",start);
					if (end < 0)
					{
						end = cookieTemp.length;
					}

					return cookieTemp.substring(start+1,end);
				}
			}
		}
		else if (persistenceMode == "brokenCookie")
		{

			var saID = getStudentAssessmentID();
			var chunkArray = new Array();

			var cookieTemp = document.cookie;
			var cookieArray = cookieTemp.split(";")

			for (var i=0; i< cookieArray.length; i++)
			{
				var cookieElementArray = cookieArray[i].split("=");
				if (cookieElementArray[0].indexOf(saID+"[") > -1)
				{
					var cookieID = cookieElementArray[0];
					var cookieValue = cookieElementArray[1];
					var sequence = parseInt(cookieID.charAt(saID.length+2));

					chunkArray[sequence] = cookieValue;
				}
			}

			var assembledCookie = "";

			for (var i=0; i<chunkArray.length; i++)
			{
				assembledCookie += chunkArray[i];
			}

			return assembledCookie;
		}
		else if (persistenceMode == "userData")
		{
			var userDataObject = document.getElementById("spnUserData");
			userDataObject.load(getStudentAssessmentID());
			return userDataObject.getAttribute("answerBody");
		}
	}
	return null;
}

function parseCookie()
{
	var rawCookieValue = getCookieValue();

	if (rawCookieValue == null)
	{
		return;
	}

	var cookieValue = unescape(rawCookieValue);

	if (window.SelectedAnswerArray == null)
	{
		SelectedAnswerArray = new Array();
	}

	var answers = cookieValue.split("^");

	for (var i=0; i<answers.length; i++)
	{
		var start = answers[i].indexOf(":");
		var tempID = answers[i].substring(0,start);

		var idArray = tempID.split("_");
		var sequence = getQuestionSequence(idArray[0],idArray[1]);

		var end = answers[i].indexOf(";",start+1);
		if (end < 0)
		{
			end = answers[i].length;
		}

		var answerString = answers[i].substring(start+1,end);

		SelectedAnswerArray[sequence] = "SelectedAnswers:"+answerString;
	}
}


function getQuestionSequence(sectionID,questionID)
{
	for (var i=0; i<QuestionArray.length; i++)
	{
		if (QuestionArray[i] == sectionID+"-"+questionID)
		{
			return i;
		}
	}
	return null;
}


function getSelectedAnswers(answerString,contentType)
{
	var selectedToken = "SelectedAnswers:";
	var begin = answerString.indexOf(selectedToken)+selectedToken.length;
	var end = answerString.length;

	var shufflePos = answerString.indexOf("^");
	if (shufflePos > -1)
	{
		end = shufflePos;
	}

	var tempString = answerString.substring(begin,end);
	if ((contentType == 100) || (contentType == 101) || (contentType == 102))
	{
		if (tempString.charAt(0) == '~')
		{
			tempString = tempString.substring(1,tempString.length);
		}
	}
	return tempString.split("~");
}


function getShuffleOrder(answerString)
{
	var shuffledToken = "Shuffled:";
	var begin = answerString.indexOf(shuffledToken)+shuffledToken.length;
	var end = answerString.length;

	var shufflePos = answerString.indexOf("^",begin);
	if (shufflePos > -1)
	{
		end = shufflePos;
	}

	var tempString = answerString.substring(begin,end);
	return tempString.split(",");
}

function initializeAssessment()
{
	parseCookie();

	var lastPage = getCurrentPage();
	if (lastPage != null)
	{
		page(parseInt(lastPage));
		//haidoan - update Navigation Bar context after jump to last saved page
		if (CbtView && typeof updateUIAfterDoNext != 'undefined') 
		{
			updateUIAfterDoNext();
		}
	}

	var assessPrefix = getPrefix("assessment");

	if (window.SelectedAnswerArray == null)
	{
		return;
	}

	for (var i=0; i<numQuestions; i++)
	{
		var SectionContentID = QuestionArray[i];

		var tempArray = SectionContentID.split("-");
        if ( tempArray.length > 1 ) 
		{
            var SectionID = tempArray[0] + '_';
            var ContentID = tempArray[1];
        }
        else 
		{
            var ContentID = tempArray[0];
        }

		var docPrefix 	= getPrefix( "Question"+SectionID+ContentID+"Form" );
		var numAnswers 	= window["NumAnswers"+ContentID];
		var contentType = parseInt(QuestionTypeArray[i]);

		if (window.SelectedAnswerArray[i] != null)
		{
			var is_Shuffled = window["lb_Shuffled"+ContentID];

			var answers = getSelectedAnswers(SelectedAnswerArray[i],contentType);

			for (var j = 0; j<numAnswers; j++) {

	            var OrigOrder = j;

				if (is_Shuffled) 
				{
	                OrigOrder = window["Shuffle"+ContentID+"Array"][j];
					OrigOrder--;
	            }

				switch (contentType)
				{
						case 23: //Linkert
						break;

						case 24: //FreeForm
						break;

						case 27: //Dragdrop

							var retObj = getXYCoords( answers[OrigOrder] );

							var dragObj = window["dragdrop"+ContentID].drags[j+1].dragObj;
								dragObj.moveTo(retObj.x,retObj.y);

						break;

						case 31: //Hotspot
							//Haidoan - 2006/Oct/16 - Fix case 12908
							if (answers[j] != null)
							{
								if (answers[j] == "-1,-1")
								{
									break;
								}

								var tempArray = answers[j].split(",");
								var clickX = parseInt(tempArray[0]);
								var clickY = parseInt(tempArray[1]);

								var clickEvent = new Object();
									clickEvent.offsetX = clickX;
									clickEvent.offsetY = clickY;
									clickEvent.layerX = clickX;
									clickEvent.layerY = clickY;

								    window["hs"+ContentID].redrawClickedItem(clickX, clickY);
							}

							break;

						case 103: //Fill in the blank

							if (answers[j] != null)
							{
								eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+OrigOrder+ContentID+".value = '"+answers[j]+"'");
							}

							break;

						case 104: //Ordering

							if (answers[j] != null)
							{
								// grab the select boxes in the order they are displayed
								var oSelect = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+(j)+ContentID);
								// loop through options and select the one that matches user's choice (from answer array)
								for (var s=0; s<oSelect.options.length; s++)
								{
									// get the orig order of this select box and check what value the user chose
									// by fetching that index from the answer array
									// (answer array has an extra index athe beginning, so add 1)
									if (oSelect.options[s].value == parseInt(answers[OrigOrder+1]))
									{
										oSelect.selectedIndex = s;
									}
								}
							}

							break;

						case 105: //Matching
								//debugger;
							if (j < 1)
							{
								if (answers != null)
								{
									for (var m=0; m<answers.length; m++)
									{
										if (answers[m].indexOf("_") < 0)
										{
											continue;
										}

										var tempArray = answers[m].split("_");
										var item 		= tempArray[0];
										var selected 	= tempArray[1];

										// Nhan: 63598-The answers that get from cookie after saving assessment, should not be shuffled
										eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+(item-1)+(selected-1)+ContentID+".checked = true;");
									}
								}
							}

						break;

						case 107: //Shockwave Assessment
						
							setShockwaveInitialAnswers(ContentID, answers[0], answers[1]);
							break;

						default:

							if (answers[j] != null)
							{
								if (answers[j] == "Y")
								{
									if (is_Shuffled)
									{
										var shuffle =  window["Shuffle"+ContentID+"Array"];
										for (var c=0; c<shuffle.length; c++)
										{
											if (shuffle[c] == j+1)
											{
												eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+"["+c+"].checked = true");
											}
										}
									}
									else
									{
										eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+"["+OrigOrder+"].checked = true");
									}
								}
							}

				}

			}
		}
	
		switch (contentType)
		{
			case (27):
				setOnMoveListenerFunction(window["dragdrop"+ContentID].drags);
				break;
			case (31):
				setOnClickListenerFuntion(window["hs"+ContentID].el);
				break;
			default:
				setOnChangeFunction(eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.elements"),SectionID+ContentID);
		}
	}
}

var fieldChangedInCurrentPage = false;
function setOnClickListenerFuntion(eventListener) 
{
	eventListener.onclick = function dofieldChanged(){if (!fieldChangedInCurrentPage) {fieldChangedInCurrentPage=true;}};
}

function setOnMoveListenerFunction(dragItems) 
{
	//Start of index = 1
	for (var i=1; i<dragItems.length; i++) 
	{
		dragItems[i].dragListener.onmove = function dofieldChanged()
		{
			if (!fieldChangedInCurrentPage) 
			{
				fieldChangedInCurrentPage=true;
			}
		};
	}
}

function setOnChangeFunction (answers, sectionContentID) 
{
	for (var i=0; i<answers.length; i++) 
	{
		answers[i].onchange = function dofieldChanged(sectionContentID)
		{
			if (!fieldChangedInCurrentPage) 
			{
				fieldChangedInCurrentPage=true;
			}
		};
	}
}
function getXYCoords( answer )
{
	var comma = answer.indexOf(",");
	var x = answer.substring(2,comma);
	var y = answer.substring(comma+1,answer.length-1);

	var retObj = new Object();
	retObj.x = parseInt(x);
	retObj.y = parseInt(y);

	return retObj;
}

//Haidoan - This variable determines whether all answers are answered or not
var all_items_are_answered = true;
function JudgeAssessment(offline, calledFrom) {

	var assessPrefix = getPrefix( "assessment" );
	var TrackingArray = new Array();
	if ( offline != null && (offline == 'build' || offline == 'rebuild' ))
	{
	  var gradeButton = eval(assessPrefix+"document.forms.assessment.Grade");
      if (gradeButton != null) {
		eval(assessPrefix+"document.forms.assessment.Grade.disabled=true;");
      }
	}
	if (offline == null )
	{
		var saveButton = eval(assessPrefix+"document.forms.assessment.Save");
		if (saveButton != null) {
			saveButton.disabled=true;
		}
	}
	var ls_response = '';
    var i = 0;

    // loop thru questions
    for (i = 0;i< numQuestions;i++) {

        SectionID = ''; // Initialize.
        // DPV 1/30/1 Change made, because the QuestionArray can now include SectionID
        var SectionContentID = QuestionArray[i];
        tempArray = SectionContentID.split("-");
        if ( tempArray.length > 1 ) {
            SectionID = tempArray[0] + '_';
            ContentID = tempArray[1];
        }
        else {
            ContentID = tempArray[0];
        }

		var docPrefix = getPrefix( "Question"+SectionID+ContentID+"Form" );
		if (docPrefix==null)  {
			alert( "Not loaded!  Close window and reload." );
			return false;
		}

		ContentType = QuestionTypeArray[i];

        var is_Shuffled = window["lb_Shuffled"+ContentID];

        var ls_answers = '';
        var numAnswers = window["NumAnswers"+ContentID];

        var AnswerArray = new Array();

		var nonanswereditemcount = 0;
        // loop thru answers for this question
        for (var j = 0;j<numAnswers;j++) {

            if (is_Shuffled) {
                OrigOrder = window["Shuffle"+ContentID+"Array"][j];
            } else {
                OrigOrder = j;
            }

            //OrigOrder --;  // start array at position 0 instead of 1

            theType = parseInt(ContentType);

            switch(theType) {

	              case 23: //Linkert
				if ( typeof(eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID + ".length")) == "undefined" )
				{
					checked=eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+".checked");
				}
				else
				{
					checked = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+"["+j+"].checked");
				}
                        if (checked) {   // the answer was checked
                            AnswerArray[OrigOrder] = 'Y';  // put the answer in the slot of the original order
                        } else {
                            AnswerArray[OrigOrder] = 'N';
                            nonanswereditemcount++;//count answered items
                        }

				  break;

				  case 24: //FreeForm

						text = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+".value;");

						//AnswerArray[OrigOrder] = escape(text);
						AnswerArray[OrigOrder] = text;
						if (AnswerArray[OrigOrder] == '') {
							nonanswereditemcount++;
						}

				  break;


				  case 27:  // drag drop
						if (is_Shuffled)
							OrigOrder--;

						var drag        = window["dragdrop"+ContentID].drags[j+1].dragObj;

                        var midX        = ((drag.x)+((drag.w)/2));
                        var midY        = ((drag.y)+((drag.h)/2));

                        var topX        = drag.targetX;
                        var topY        = drag.targetY;
                        var botX        = ((drag.targetX) + (drag.targetW));
                        var botY        = ((drag.targetY) + (drag.targetH));

						if (drag.isDistractor) {
                            AnswerArray[OrigOrder] = "D(" + drag.x + "," + drag.y + ")";
                        }
                        else {
                            if ((midX > topX) && (midX < botX) && (midY > topY) && (midY < botY)) {
                                AnswerArray[OrigOrder] = "1(" + drag.x + "," + drag.y + ")";
                            }
							else  {
								AnswerArray[OrigOrder] = "0(" + drag.x + "," + drag.y + ")";
							}
                        }
                        if (drag.x == drag.startX && drag.y == drag.startY) {
							nonanswereditemcount++;
						}

						break;

                  case 31: //Hotspot

						//answerValue = eval( docPrefix + "document.Question"+SectionID+ContentID+"Form.Answer"+(j+1)+ContentID+".value;");
					    answers = window["hs"+ContentID].clickAnswerArray;
						answerValue = answers[j+1];

                        if (answerValue == '' || answerValue == null) {
							answerValue = '-1,-1';
							nonanswereditemcount++;
						}

                        AnswerArray[OrigOrder] = answerValue;

                        break;

                  case 103:               // fill in the blank

                        answerValue = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+ContentID+".value;");
                        if ( RTrim(answerValue) == "" )  {
							answerValue = " ";
							nonanswereditemcount++;
                        }
						else  {
							answerValue=RTrim(answerValue);
							answerValue=LTrim(answerValue);
						}
                        AnswerArray[OrigOrder] = answerValue;

                        break;

                  case 104:               // ordering
  						selectedIndex = eval( docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+ContentID+".selectedIndex" );
  						answerValue = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+ContentID+".options["+ selectedIndex +"].value;");
						AnswerArray[OrigOrder] = answerValue;
						//Haidoan - if answer is not selected, answer's value will be greater than number of answers (currently value=numberofanswers+1)
						if (parseInt(AnswerArray[OrigOrder]) == (numAnswers+1))
							nonanswereditemcount++;
                        break;

                  case 105:              // matching

                        var numChoices = window["NumChoices"+ContentID];
                        var theAnswer = '';
                        var theMatch = '';
						var theMatches = '';
						var choicecount = 0;
						var form = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form");
						if(numChoices==1)
                        {
                            if (eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+"0"+ContentID+".checked==true;")) {
                                theNum = eval(docPrefix+"document.Question"+SectionID +ContentID+"Form.Answer"+j+"0"+ContentID+".value;");
                                if ( is_Shuffled )
                                {
                                    if ( calledFrom == "scoreButton" )
                                    {
                                        // if it's shuffled, grab it's original spot from the shuffle array
                                        theAnswer = window["Shuffle"+ContentID+"Array"][theNum-1];
                                        theMatch = (j+1) + "_" + theAnswer;
                                    }
                                    else
                                    {
                                        //Nhan: 63598 - When saving, the answers should not be shuffled
                                        theAnswer = theNum;
                                        theMatch = (j+1) + "_" + theAnswer;
                                    }
                                }
                                else
                                {
                                    // if it's not shuffled, then it is in it's original spot
                                    theAnswer = theNum;
                                    theMatch = (j+1) + "_" + theAnswer;
                                }
                                if (theMatches > '') { theMatches += '~'; }
                                // add the Match to the string of matches
                                theMatches += theMatch;
                           }
                           if (choicecount <= 0) nonanswereditemcount++;

                        }
                        else
                        {
                            for (c=0; c<numChoices; c++) {
                                if (eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+c+ContentID+".checked==true;")) {
                                    // this is the ans that they chose - need to get it's original placement
                                    theNum = eval(docPrefix+"document.Question"+SectionID +ContentID+"Form.Answer"+j+c+ContentID+".value;")
                                    if ( is_Shuffled )
                                    {
                                        if ( calledFrom == "scoreButton" )
                                        {
                                            // if it's shuffled, grab it's original spot from the shuffle array
                                            theAnswer = window["Shuffle"+ContentID+"Array"][theNum-1];
                                            theMatch = (j+1) + "_" + theAnswer;
                                        }
                                        else
                                        {
                                            //Nhan: 63598 - When saving, the answers should not be shuffled
                                            theAnswer = theNum;
                                            theMatch = (j+1) + "_" + theAnswer;
                                        }
                                    }
                                    else
                                    {
                                        // if it's not shuffled, then it is in it's original spot
                                        theAnswer = theNum;
                                        theMatch = (j+1) + "_" + theAnswer;
                                    }
                                    if (theMatches > '') { theMatches += '~'; }
                                    // add the Match to the string of matches
                                    theMatches += theMatch;
                                	choicecount++;
                                }
                            }
                            if (choicecount <= 0) nonanswereditemcount++;
                        }
                        // add to the AnswerArray (order does not reall matter here.  what matters is the matches
                        // they will be compared to actuall matches later.  if you answer too many, then you will be penalized
                        // DPV 05/09/03 Modified to use "j" instead of OrigOrder because for Matching, it is the number of Answers that matters.
                        AnswerArray[j] = theMatches;

                        break;

                 case 107:              // shockwaveAssessment

						var type = window["objType"+ContentID];
						var endSettingOption = window["endSettingOption"+ContentID];
						if( type!="dcr" && endSettingOption == "1" )
						{
							window["setValues"+ContentID](ContentID,window["SWF"+ContentID]);
						}

						AnswerArray[j] = [window["answer"+ContentID],window["score"+ContentID],window["maxScore"+ContentID],window["stem"+ContentID]].join("~");

	                    break;

                 case 108:              // shockwaveSurvey

					 var type = window["objType"+ContentID];
					 var endSettingOption = window["endSettingOption"+ContentID];

					 if( type!="dcr" ) 
					 {
						 if ( endSettingOption == "1" ) 
						 {
							 var str = window["setValues"+ContentID](ContentID,window["SWF"+ContentID]);
						 }
					 }

					AnswerArray[j]= window["answer"+ContentID];
                    break;


				case 109:              // SoftSim

					// get the tracking data to send back to the server
					var data = window["contentObj"+ContentID].trackingData;
					TrackingArray[i] = data.toXML();

					AnswerArray[j]   = window["answer"+ContentID] + "~" + window["score"+ContentID] + "~" + window["maxScore"+ContentID] + "~" + window["stem"+ContentID];
					break;

                default:                // T/F, MCMA, MCSA

						if (numAnswers==1)  {
							checked = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+".checked");
						} else  {
							checked = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+"["+j+"].checked");
						}
                        if (checked) {   // the answer was checked
                            AnswerArray[OrigOrder] = 'Y';  // put the answer in the slot of the original order
                        } else {
                            AnswerArray[OrigOrder] = 'N';
                            nonanswereditemcount++;//count answered items
                        }

                        break;

            }  // end switch

        }  // end for - next answer

		var contentType = parseInt(ContentType);
		//business logic not clear, so We don't count on some content-type, such as softsim
		if (contentType != 107 && contentType != 108 && contentType != 109) {
			if (all_items_are_answered) { //if flag was checked, don't do it again
				if (nonanswereditemcount >= numAnswers)
					all_items_are_answered = false;
			}
		}

		ls_answers = AnswerArray.join("~");
//		alert( 'Anaswer: ' + ls_answers );

        if (ls_response > '') { ls_response += '^'; }
        ls_response += SectionID + ContentID+':'+ls_answers;

        if (is_Shuffled) {
            ls_shuffle = window["Shuffle"+ContentID+"Array"].toString();
            ls_response += ";ShuffleOrder:"+ls_shuffle;
        }

    }  // end for - next question

	if (offline != null && offline == 'download' )
	{
		setCookieValue(ls_response);
	}


	ls_trackingData = TrackingArray.join("^");
	//alert( 'joined ls_trackingData: ' + ls_trackingData );

	//alert('response '+ls_response);
	var assessPrefix = getPrefix( "assessment" );
    eval(assessPrefix+"document.assessment.answers.value = ls_response;");
	eval(assessPrefix+"document.assessment.runtime_data.value = ls_trackingData;");

	return true;
}

var current_sectionIDs = "";
function JudgeAssessmentInCurrentPage(offline, calledFrom) {
	
	currentPage = getCurrentPage();

	var assessPrefix = getPrefix( "assessment" );
	var minIndex = 0;var maxIndex = 0;
	if(typeof questionsPerPage != 'undefined') {
		minIndex = (currentPage-1)*questionsPerPage;
		maxIndex = (minIndex+questionsPerPage>numQuestions)?numQuestions-1: minIndex+questionsPerPage-1;
	} else {
		minIndex = maxIndex = currentPage-1;
	}
	//alert("min: " + minIndex + "; max: " + maxIndex);
	//If we dont's have any data in answers, so we have to create them first

	if (eval(assessPrefix+"document.assessment.answers.value == 'None'")) {
	//if (window.SelectedAnswerArray[0] == null) {
		minIndex = 0;
		maxIndex = numQuestions-1;
	}

	var assessPrefix = getPrefix( "assessment" );
	var TrackingArray = new Array();
	if ( offline != null && (offline == 'build' || offline == 'rebuild' ))
	{
	  var gradeButton = eval(assessPrefix+"document.forms.assessment.Grade");
      if (gradeButton != null) {
		eval(assessPrefix+"document.forms.assessment.Grade.disabled=true;");
      }
	}
	var ls_response = '';
    var i = 0;

	var current_sectionid = "";
    // loop thru questions
	//debugger;
    for (i = minIndex;i<= maxIndex;i++) {

        SectionID = ''; // Initialize.
        // DPV 1/30/1 Change made, because the QuestionArray can now include SectionID
        var SectionContentID = QuestionArray[i];
        tempArray = SectionContentID.split("-");
        if ( tempArray.length > 1 ) {
            SectionID = tempArray[0] + '_';
            ContentID = tempArray[1];
        }
        else {
            ContentID = tempArray[0];
        }
		if (current_sectionid!=tempArray[0]) {
			current_sectionid = tempArray[0];

			current_sectionIDs += (current_sectionIDs=="")?current_sectionid: "_" + current_sectionid;
		}
		var docPrefix = getPrefix( "Question"+SectionID+ContentID+"Form" );
		if (docPrefix==null)  {
			alert( "Not loaded!  Close window and reload." );
			return false;
		}

		ContentType = QuestionTypeArray[i];

        var is_Shuffled = window["lb_Shuffled"+ContentID];

        var ls_answers = '';
        var numAnswers = window["NumAnswers"+ContentID];

        var AnswerArray = new Array();

        // loop thru answers for this question
        for (var j = 0;j<numAnswers;j++) {

            if (is_Shuffled) {
                OrigOrder = window["Shuffle"+ContentID+"Array"][j];
            } else {
                OrigOrder = j;
            }

            //OrigOrder --;  // start array at position 0 instead of 1

            theType = parseInt(ContentType);

            switch(theType) {

	              case 23: //Linkert
				if ( typeof(eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID + ".length")) == "undefined" )
				{
					checked=eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+".checked");
				}
				else
				{
					checked = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+"["+j+"].checked");
				}
                        if (checked) {   // the answer was checked
                            AnswerArray[OrigOrder] = 'Y';  // put the answer in the slot of the original order
                        } else {
                            AnswerArray[OrigOrder] = 'N';
                        }

				  break;

				  case 24: //FreeForm

						text = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+".value;");

						//AnswerArray[OrigOrder] = escape(text);
						AnswerArray[OrigOrder] = text;


				  break;


				  case 27:  // drag drop

						if (is_Shuffled)
							OrigOrder--;

						var drag        = window["dragdrop"+ContentID].drags[j+1].dragObj;

                        var midX        = ((drag.x)+((drag.w)/2));
                        var midY        = ((drag.y)+((drag.h)/2));

                        var topX        = drag.targetX;
                        var topY        = drag.targetY;
                        var botX        = ((drag.targetX) + (drag.targetW));
                        var botY        = ((drag.targetY) + (drag.targetH));

						if (drag.isDistractor) {
                            AnswerArray[OrigOrder] = "D(" + drag.x + "," + drag.y + ")";
                        }
                        else {
                            if ((midX > topX) && (midX < botX) && (midY > topY) && (midY < botY)) {
                                AnswerArray[OrigOrder] = "1(" + drag.x + "," + drag.y + ")";
                            }
							else  {
								AnswerArray[OrigOrder] = "0(" + drag.x + "," + drag.y + ")";
							}
                        }

						break;

                  case 31: //Hotspot

						//answerValue = eval( docPrefix + "document.Question"+SectionID+ContentID+"Form.Answer"+(j+1)+ContentID+".value;");
					    answers = window["hs"+ContentID].clickAnswerArray;
						answerValue = answers[j+1];

                        if (answerValue == '' || answerValue == null) {
							answerValue = '-1,-1';
						}

                        AnswerArray[OrigOrder] = answerValue;

                        break;

                  case 103:               // fill in the blank

                        answerValue = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+ContentID+".value;");
                        if ( RTrim(answerValue) == "" )  {
							answerValue = " ";
                        }
						else  {
							answerValue=RTrim(answerValue);
							answerValue=LTrim(answerValue);
						}
                        AnswerArray[OrigOrder] = answerValue;

                        break;

                  case 104:               // ordering

  						selectedIndex = eval( docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+ContentID+".selectedIndex" );
  						answerValue = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+ContentID+".options["+ selectedIndex +"].value;");
						AnswerArray[OrigOrder] = answerValue;

                        break;

                  case 105:              // matching

                        var numChoices = window["NumChoices"+ContentID];
                        var theAnswer = '';
                        var theMatch = '';
						var theMatches = '';

						var form = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form");
						if(numChoices==1)
                        {
                            if (eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+"0"+ContentID+".checked==true;")) {
                                theNum = eval(docPrefix+"document.Question"+SectionID +ContentID+"Form.Answer"+j+"0"+ContentID+".value;");
                                if ( is_Shuffled )
                                {
                                    if ( calledFrom == "scoreButton" )
                                    {
                                        // if it's shuffled, grab it's original spot from the shuffle array
                                        theAnswer = window["Shuffle"+ContentID+"Array"][theNum-1];
                                        theMatch = (j+1) + "_" + theAnswer;
                                    }
                                    else
                                    {
                                        //Nhan: 63598 - When saving, the answers should not be shuffled
                                        theAnswer = theNum;
                                        theMatch = (j+1) + "_" + theAnswer;
                                    }
                                }
                                else
                                {
                                    // if it's not shuffled, then it is in it's original spot
                                    theAnswer = theNum;
                                    theMatch = (j+1) + "_" + theAnswer;
                                }
                        if (theMatches > '') { theMatches += '~'; }
                        // add the Match to the string of matches
                        theMatches += theMatch;

                           }
                        }
                        else
                        {
                            for (c=0; c<numChoices; c++) {
                                if (eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+j+c+ContentID+".checked==true;")) {
                                    // this is the ans that they chose - need to get it's original placement
                                    theNum = eval(docPrefix+"document.Question"+SectionID +ContentID+"Form.Answer"+j+c+ContentID+".value;")
                                    if ( is_Shuffled )
                                    {
                                        if ( calledFrom == "scoreButton" )
                                        {
                                            // if it's shuffled, grab it's original spot from the shuffle array
                                            theAnswer = window["Shuffle"+ContentID+"Array"][theNum-1];
                                            theMatch = (j+1) + "_" + theAnswer;
                                        }
                                        else
                                        {
                                            //Nhan: 63598 - When saving, the answers should not be shuffled
                                            theAnswer = theNum;
                                            theMatch = (j+1) + "_" + theAnswer;
                                        }
                                    }
                                    else
                                    {
                                        // if it's not shuffled, then it is in it's original spot
                                        theAnswer = theNum;
                                        theMatch = (j+1) + "_" + theAnswer;
                                    }
                                    if (theMatches > '') { theMatches += '~'; }
                                    // add the Match to the string of matches
                                    theMatches += theMatch;

                                }
                            }
                        }
                        // add to the AnswerArray (order does not reall matter here.  what matters is the matches
                        // they will be compared to actuall matches later.  if you answer too many, then you will be penalized
                        // DPV 05/09/03 Modified to use "j" instead of OrigOrder because for Matching, it is the number of Answers that matters.
                        AnswerArray[j] = theMatches;

                        break;
                 case 107:              // shockwaveAssessment

                      var type = window["objType"+ContentID];
                      var endSettingOption = window["endSettingOption"+ContentID];
                      if( type!="dcr" && endSettingOption == "1" )
                      {
                            window["setValues"+ContentID](ContentID,window["SWF"+ContentID]);
                       }

	                   AnswerArray[j]   = window["answer"+ContentID] + "~" + window["score"+ContentID] + "~" + window["maxScore"+ContentID] + "~" + window["stem"+ContentID];
	                         //alert(AnswerArray[j]);
	                    break;

                 case 108:              // shockwaveSurvey

					 var type = window["objType"+ContentID];
					 var endSettingOption = window["endSettingOption"+ContentID];

					 if( type!="dcr" ) {
						 if ( endSettingOption == "1" ) {
							 window["setValues"+ContentID](ContentID,window["SWF"]);
						 }
					 }

					AnswerArray[j]= window["answer"+ContentID];
                    break;


				case 109:              // SoftSim

					// get the tracking data to send back to the server
					var data = window["contentObj"+ContentID].trackingData;
					TrackingArray[i] = data.toXML();

					AnswerArray[j]   = window["answer"+ContentID] + "~" + window["score"+ContentID] + "~" + window["maxScore"+ContentID] + "~" + window["stem"+ContentID];
					break;

                default:                // T/F, MCMA, MCSA

						if (numAnswers==1)  {
							checked = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+".checked");
						} else  {
							checked = eval(docPrefix+"document.Question"+SectionID+ContentID+"Form.Answer"+ContentID+"["+j+"].checked");
						}
                        if (checked) {   // the answer was checked
                            AnswerArray[OrigOrder] = 'Y';  // put the answer in the slot of the original order
                        } else {
                            AnswerArray[OrigOrder] = 'N';
                        }

                        break;

            }  // end switch

        }  // end for - next answer

		ls_answers = AnswerArray.join("~");
//		alert( 'Anaswer: ' + ls_answers );

        if (ls_response > '') { ls_response += '^'; }
        ls_response += SectionID + ContentID+':'+ls_answers;

        if (is_Shuffled) {
            ls_shuffle = window["Shuffle"+ContentID+"Array"].toString();
            ls_response += ";ShuffleOrder:"+ls_shuffle;
        }

    }  // end for - next question

	if (offline != null && offline == 'download' )
	{
		setCookieValue(ls_response);
	}


	ls_trackingData = TrackingArray.join("^");
	//alert( 'joined ls_trackingData: ' + ls_trackingData );

	//alert('response '+ls_response);
	var assessPrefix = getPrefix( "assessment" );
    eval(assessPrefix+"document.assessment.answers.value = ls_response;");
	eval(assessPrefix+"document.assessment.runtime_data.value = ls_trackingData;");

	return true;
}

function getPrefix( formname )  {

	var prefix = "";
	if (document.layers)  {
		var layerName = "";
		for (k=0; k<document.layers.length; k++)  {
			var form = eval("document.layers["+k+"].document."+formname);
			if ( form != null )
				layerName = document.layers[k].name;

		}
		if (layerName=="")
			return null;

		prefix = "document."+layerName+".";
	}

	return prefix;
}

// replacement for getPrefix
//   - requires use of no eval statements
function getForm(formName, doc)
{
    var searchDoc = (arguments[1] || document);
    var form = searchDoc.forms[formName];

    // ns4x - search layers
    if (document.layers)
    {
        for (var i=0; i<searchDoc.layers.length; i++)
        {
            form = findFormInLayer(searchDoc.layers[i], formName);

            if (form != null)
            {
                // found it
                break;
            }
        }
    }

    return form;
}

function findFormInLayer(lyr, formName)
{
    var form = null;

    // only do this for ns4x
    if (document.layers)
    {
        // look through all the forms in this layer
        for (var f=0; f<lyr.document.forms.length; f++)
        {
            var tempForm = lyr.document.forms[f];
            if (tempForm != null)
            {
                if (tempForm.name == formName)
                {
                    // found it
                    form = tempForm;
                    break;
                }
            }
        }

        // search child layers if we haven't found it yet
        if (form == null)
        {
            for (var i=0; i<lyr.document.layers.length; i++)
            {
                var tempForm = findFormInLayer(document.layers[i], formName);
                if (tempForm != null)
                {
                    // found it
                    form = tempForm;
                    break;
                }
            }
        }
    }

    return form;
}

function LTrim(passString) {
    passString=" "+passString;
    while(passString.charAt(0)==' ') {
        passString=passString.substring(1,passString.length);
    }
    return passString;
}

function RTrim(passString) {
    passString+=" ";
    while(passString.charAt(passString.length-1)==' ') {
        passString=passString.substring(0,passString.length-1);
    }
    return passString;
}

function doAjaxInteraction() 
{
	//Build URL
	var assessmentForm = document.forms['assessment'];
	var parameters = "answers=" + encodeURI(assessmentForm.answers.value);
	parameters += "&runtime_data=" + encodeURI(assessmentForm.runtime_data.value);
	parameters += "&assessID=" + encodeURI(assessmentForm.assessID.value);
	parameters += "&sectionOrder=" + encodeURI(current_sectionIDs);//+ encodeURI(assessmentForm.sectionOrder.value);
	parameters += "&studentID=" + encodeURI(assessmentForm.studentID.value);
	parameters += "&studentAssessID=" + encodeURI(assessmentForm.studentAssessID.value);
	parameters += "&courseID=" + encodeURI(assessmentForm.courseID.value);
	parameters += "&themeID=" + encodeURI(assessmentForm.themeID.value);
	parameters += "&showCloseBtn=" + encodeURI(assessmentForm.showCloseBtn.value);
	parameters += "&doModal=" + encodeURI(assessmentForm.doModal.value);
	parameters += "&calledFrom=" + encodeURI(assessmentForm.calledFrom.value);
	parameters += "&lParm=" + encodeURI(assessmentForm.lParm.value);
	parameters += "&submitStatus=quicksave";
	if (typeof myTimer != 'undefined')
		parameters += "&timeleft=" + myTimer.getRemaining();
	else
		parameters += "&timeleft=-1";
	parameters += "&currentPage=" + encodeURI(currentPage);
	parameters += "&objectID=" + encodeURI(assessmentForm.objectID.value);
	parameters += "&objectTypeID=" + encodeURI(assessmentForm.objectTypeID.value);
    var url = assessmentForm.action;
    var ajax = new AJAXInteraction(url, parameters, saveCallback);
    ajax.doPost();
}

function saveCallback(req) 
{
	var root = req.responseXML.getElementsByTagName("root")[0];
	if (root != null) 
	{
		var _status = root.childNodes[0].text;
		var url = root.childNodes[1].text;
		if (_status != null && _status == "expired") 
		{
			this.location.href = unescape(url);
		}
	}
}

function page(num)
{
	if (fieldChangedInCurrentPage && !bExported) 
	{
		//Update data for current page
		JudgeAssessmentInCurrentPage(null, "");
		doAjaxInteraction();
	}
	
	fieldChangedInCurrentPage = false;
	current_sectionIDs = "";

	updatePageNumber(num);
	currentPage = num;

	if (document.layers)
	{
        for (var i=1;i<=pageCount;i++)
        {
            document.layers["Page"+i].visibility = "hide";
        }
        document.layers["Page"+num].visibility = "show";
    }
    else
    {
        for (var i=1;i<=pageCount;i++)
        {
            document.getElementById("Page"+i).style.visibility = "hidden";
        }

        document.getElementById("Page"+num).style.visibility = "visible";
    }
}

function previousPage()
{
	if ( currentPage == 1 )
	{
		// They are already on the first page
		return false;
	}
	else
	{
		page(currentPage-1);
	}
}

function nextPage()
{
	if ( currentPage == pageCount )
	{
		// They are already on the last page
		return false;
	}
	else
	{
		page(currentPage+1);
	}
}

function updatePageNumber(currentPage)
{
	var activePageClass = (mode=="survey") ? "bs-activePage" : "ba-activePage";
	var pageNumberClass = (mode=="survey") ? "bs-pagenumberstyle" : "ba-pagenumberstyle";

	var newHTML = "<table width=\"100%\" border=\"0\" cellpadding=\"5\" cellspacing=\"1\">\n"+
	              "  <tr>\n"+
	              "    <td class=\""+pageNumberClass+"\">"+pageNumberLabel+"</td>\n"+
	              "    <td class=\""+pageNumberClass+"\" width=\"99%\">\n";

	for (var i=0;i<pageCount;i++)
	{
		var page = i+1;
		if (currentPage == page)
		{
			newHTML += "      <span class=\""+activePageClass+"\">"+page+"</span>&nbsp;\n";
		}
		else
		{
			newHTML += "      <a class=\""+pageNumberClass+"\" href=\"javascript:page("+page+");\">"+page+"</a>&nbsp;\n";
		}
	}

	newHTML +=  "    </td>\n"+
	            "  </tr>\n"+
	            "</table>\n";

    // ns4 needs padding
	if (document.layers)
	{
		var newHTML = "<span class=\"nspadding\">"+newHTML+"</span>";
	}

    // use the DynAPI
	var pagediv = DynAPI.document.all["pagenavdiv"];
		pagediv.setHTML(newHTML);
}

function score() {
    document.forms['assessment'].submit();
}

function getLearningObjectReference(win)
{
    var ref = win.top.LEARNING_OBJECT;

    if ((win != opener) && (ref == null) && (opener != null))
        ref = getLearningObjectReference(opener);

    return ref
}

function syncAssessment(a)
{
    var loRef = getLearningObjectReference(window);
    if (loRef)
    {
		var dest = loRef.getAssessment(a.getID());
		if (dest != null) dest.copy(a);
    }
}

function checkReload() 
{
  if (window.history.length>0) window.history.go(1);
}

function getAssessmentForm() 
{
	if (document.layers) { return document.layers['footerdiv'].document.forms.assessment; }
	else {					return document.forms['assessment']; }
}
function seqNav(action) 
{
	if (!this.submitted) 
	{
		var assessForm = getAssessmentForm();
			assessForm.calledFrom.value = 'sequenceViewer';
			assessForm.target = "hidden";
			assessForm.seqAction.value = action;

		JudgeAssessment(assessmentMode, 'scoreButton');
		
		assessForm.submitStatus.value = 'score';
		assessForm.submit(); 
		this.submitted = true;
		return true; 
	}
	return false;
}

function submitJudgeAssessment(calledFrom) 
{ 
     if (this.timeoutwarning) 
	 {
		timeoutwarning.close();      
		if (this.simViewerWin) 
		{
			simViewerWin.close();
			if ( scoredFlag == true) 
			{
				return;  
			}
		}
	}
	
	var assessForm = getAssessmentForm();
	var scoringMessage = 'Please wait... Your exam is being scored...'; 
	var saveMessage = 'Please wait... Your assessment is being saved...'; 
	var unLoadMessage = scoringMessage;
	
	if ( assessmentMode == "download") 
	{
		unLoadMessage = saveMessage; 
	}
	
    assessForm.calledFrom.value = calledFrom;
    assessForm.target = "hidden";
	if ((calledFrom == 'scoreButton')) 
	{
		if (notallcompleted_user_answer==false) 
		{
			var grade = document.getElementById('Grade');
			if (grade!=null) grade.disabled=false;
			var gradefooter = document.getElementById('GradeFooter'+getCurrentPage());
			if (gradefooter!=null) gradefooter.disabled=false;
			//for cbt theme, put here
			return;
		}
	}
	
	if ((calledFrom == 'saveButton' || calledFrom == 'onUnLoad' ) && assessmentMode == 'download' ) 
	{
  		return;
	}

 	scoredFlag = true;
 	if ( typeof myTimer != 'undefined' && myTimer != null ) 
	{
 	    assessForm.timeleft.value = myTimer.getRemaining();
	} 
	else 
	{
		assessForm.timeleft.value = -1;
	}
 	enableOpenerNavigation(); 
	if (calledFrom == 'onUnLoad') 
	{
		if (typeof saveMode != 'undefined' && (saveMode || (typeof score_or_save != 'undefined'))) 
		{
 			assessForm.submitStatus.value = score_or_save?'score':'save';
     		assessForm.submit();
		}
	}
	else if (calledFrom == 'scoreButton') 
	{
 		assessForm.submitStatus.value = 'score';
     	assessForm.submit();
	}
	else if ( calledFrom == 'saveButton' ) 
	{
 		assessForm.submitStatus.value = 'save';
 		assessForm.currentPage.value = currentPage;
     	assessForm.submit();
	}
	else if ( calledFrom == 'downloadButton') 
	{
			downloadWindow = window.open('','downloadWindow', 'scrollbars=yes,width=200,height=200,status=yes,resizable=yes');
			downloadWindow.document.writeln('<html><body>');
	 		downloadWindow.document.writeln('Please wait... Your exam is being built...');
	 		downloadWindow.document.writeln('<\/body><\/html>');
	 		downloadWindow.document.close();
	 		downloadWindow.focus();
			assessForm.Download.disabled = true;
			assessForm.submitStatus.value = 'download';
			assessForm.currentPage.value = currentPage;
			assessForm.target = 'downloadWindow';
			assessForm.submit();

			document.location.href = "BuildAssessment?studentID="+assessForm.studentID.value+"&assessID="+assessForm.assessID.value+"&objectID="+assessForm.objectID.value+"&objectTypeID="+assessForm.objectTypeID.value+"&themeID="+assessForm.themeID.value+"&doModal="+doModalAssessment;
	}
	else 
	{
 		assessForm.submitStatus.value = 'score';
		assessForm.submit();
	}
}
function enableOpenerNavigation() 
{ 
	if (opener && opener.parent && opener.parent.frames && opener.parent.frames.footer && opener.parent.frames.footer.PrevGroupBtn) 
	{
		opener.parent.frames.footer.enablePrevButton();
	} 

	if (opener && opener.parent && opener.parent.frames && opener.parent.frames.footer && opener.parent.frames.footer.NextGroupBtn) 
	{ 
		opener.parent.frames.footer.enableNextButton();
	} 
} 

var myTimer = null;
function initTimer(base) 
{ 
	myTimer = new Timer(10800, base); 
	myTimer.setWarning(60); 
	myTimer.setVisible(true); 
	myTimer.setLabel('Time Left:'); 
	myTimer.setTimerTextStyle('ba-timertextstyle'); 
	myTimer.onexpire=expired; 
	myTimer.onwarning=warning; 
	myTimer.start(); 
} 

function expired() 
{ 
	JudgeAssessment(assessmentMode, 'scoreButton'); 
	submitJudgeAssessment('timerexpired'); 
} 

var timeoutwarning = null;
function warning() 
{
	var url = 'TimeoutWarning?assessID='+ getAssessmentForm().assessID.value;
	    url += '&studentAssessID='+ getAssessmentForm().studentAssessID.value;
	    url += '&studentID='+ getAssessmentForm().studentID.value;
	    url += '&themeID='+ getAssessmentForm().themeID.value;
		
	timeoutwarning = window.open(url,'TimeoutWarning','width=300,height=100,toolbars=no,location=no'); 
	timeoutwarning.focus(); 
}
function gradeButtonClickHandler()
{
	all_items_are_answered=true;
	notallcompleted_user_answer=true;
	JudgeAssessment(assessmentMode, 'scoreButton');
	if (!all_items_are_answered) 
	{
		notallcompleted_user_answer=confirm('You did not provide an answer to every question in the assessment. Do you want to continue scoring the assessment?');
		if (!notallcompleted_user_answer)
		{
			var grade = document.getElementById('Grade');
			if (grade!=null) grade.disabled=false;
			return;
		}
	}
	submitJudgeAssessment('scoreButton');
	prompt_check =  true;
}

AssessmentBeforeUnloadHandler=function(evt)
{
	var agt = navigator.userAgent.toLowerCase();  
	var is_ie  = ((agt.indexOf('msie') != -1) && (agt.indexOf('opera') == -1));  
	var evt = (evt)?evt:window.event;
	var y = (window.event) ? evt.clientY: evt.pageY;
	
	//if it's embedded then not show warning
	if (this.opener == null) {return;} 
	if (is_ie)
	{
		if ( (typeof(y) != 'undefined' && y>=0)) return;
	}
	
	if ( prompt_check ) return;

	prompt_check =  true;

	if (!scoredFlag) 
	{ 
		if(saveMode) 
		{
			score_or_save=confirm('The assessment is closing.  Hit the OK button to submit the assessment and receive a score.  Hit the Cancel button to save the assessment to be completed later.');
			assessment.calledFrom.value = score_or_save? 'scoreButton':'saveButton'; 
		}
		else
		{
			assessment.calledFrom.value = 'scoreButton';
		} 
		this.submitted = false; 
	}

	if (score_or_save) 
	{
		if (saveMode) 
		{
			all_items_are_answered=true;
			notallcompleted_user_answer=true;
			JudgeAssessment(assessmentMode, 'scoreButton');
			
			if(!all_items_are_answered) 
			{
				notallcompleted_user_answer=confirm('You did not provide an answer to every question in the assessment. Do you want to continue scoring the assessment?');if(notallcompleted_user_answer ==false){var grade = document.getElementById('Grade');if (grade!=null) grade.disabled=false;return;}
			}
		}
		else 
		{
			all_items_are_answered=true;
			notallcompleted_user_answer=true;
			JudgeAssessment(assessmentMode, 'scoreButton');
		}
	}
	else
	{ 
    	if (saveMode) 
		{
			all_items_are_answered=true;
        	notallcompleted_user_answer=true;
			JudgeAssessment(assessmentMode, 'scoreButton');
    	}
	}
	
	if(this.submitted) return false; 
	
	assessment.target = 'hidden'; 
	submitJudgeAssessment(assessment.calledFrom.value); 
    notallcompleted_user_answer=true;
    all_items_are_answered=true;
    this.submitted = true; 
};

function CBTMouseEventHandler(e) 
{
	if (e.button == 3) 
	{
		e.cancelBrowserEvent();  
	}  
}

function attachDocumentListeners()
{
	var listener = new EventListener(DynAPI.document);
	listener.onrtmousedown   = CBTMouseEventHandler;
	listener.onrtmouseup     = CBTMouseEventHandler;
	DynAPI.document.addEventListener(listener);
}